%define kname   kernel-uml
%define	name	%{kname}

%define	kversion	2.6.28
%define patchversion 8
%define rel %mkrel 1

%define mdvk %{rel}
%define kernelversionappend -uml.%{mdvk}
%define rpmversion %{kversion}%{?patchversion:.%{patchversion}}
%define mdvkversion %{kversion}%{?patchversion:.%{patchversion}}.%{mdvk}
%define	release	%rel

%define	Summary	The user mode linux kernel

%define bmodulesv %{?!_without_modules:1}%{?_without_modules:0}

Summary:	%{Summary}
Name:		%{name}
Version:	%{rpmversion}
Release:	%{release}
Group:		System/Kernel and hardware

Source0:	linux-%{kversion}.tar.bz2
Source1:    %{name}-config
Source50:   README.mdv
%if %{?patchversion:1}%{?!patchversion:0}
Patch0:     patch-%{kversion}.%{patchversion}.bz2
# upstream patch
# Signed-off-by: WANG Cong <wangcong[at]zeuux.org>
Patch1:     link-error.patch
%endif
License:	GPL
Url:		http://user-mode-linux.sourceforge.net/
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildRequires:	glibc-static-devel
BuildRequires:  pcap-devel
Requires:       %{kname}-%{_target_cpu} = %{version}-%{release}

%description
User-Mode Linux is a safe, secure way of running Linux versions and
Linux processes. Run buggy software, experiment with new Linux kernels
or distributions, and poke around in the internals of Linux, all
without risking your main Linux setup.

User-Mode Linux gives you a virtual machine that may have more hardware
and software virtual resources than your actual, physical computer. Disk
storage for the virtual machine is entirely contained inside a single
file on your physical machine. You can assign your virtual machine only
the hardware access you want it to have. With properly limited access,
nothing you do on the virtual machine can change or damage your real
computer, or its software.

%package    %{_target_cpu}
Group:		System/Kernel and hardware
Summary:	%{Summary}
Requires:   %{kname}-%{_target_cpu}-%{mdvkversion}

%description %{_target_cpu}
User-Mode Linux is a safe, secure way of running Linux versions and
Linux processes. Run buggy software, experiment with new Linux kernels
or distributions, and poke around in the internals of Linux, all
without risking your main Linux setup.

User-Mode Linux gives you a virtual machine that may have more hardware
and software virtual resources than your actual, physical computer. Disk
storage for the virtual machine is entirely contained inside a single
file on your physical machine. You can assign your virtual machine only
the hardware access you want it to have. With properly limited access,
nothing you do on the virtual machine can change or damage your real
computer, or its software.

%package    %{_target_cpu}-%{mdvkversion}
Group:		System/Kernel and hardware
Summary:	%{Summary}
Requires:   uml-utilities
Version:    1
Release:    1

%description %{_target_cpu}-%{mdvkversion}
User-Mode Linux is a safe, secure way of running Linux versions and
Linux processes. Run buggy software, experiment with new Linux kernels
or distributions, and poke around in the internals of Linux, all
without risking your main Linux setup.

User-Mode Linux gives you a virtual machine that may have more hardware
and software virtual resources than your actual, physical computer. Disk
storage for the virtual machine is entirely contained inside a single
file on your physical machine. You can assign your virtual machine only
the hardware access you want it to have. With properly limited access,
nothing you do on the virtual machine can change or damage your real
computer, or its software.

%package modules-%{mdvkversion}
Group:		System/Kernel and hardware
Summary:	Kernel module for UML kernel
AutoReqProv: No
Version:    1
Release:    1
Provides:   %{kname}-modules

%description modules-%{mdvkversion}
User-Mode Linux is a safe, secure way of running Linux versions and
Linux processes. Run buggy software, experiment with new Linux kernels
or distributions, and poke around in the internals of Linux, all
without risking your main Linux setup.

This package contains modules need inside the virtual machine when using
UML kernel compiled to use module.

This package has to be installed inside the VM, not on your system !

%prep
%setup -q -n linux-%{kversion}
%if %{?patchversion:1}%{?!patchversion:0}
%patch0 -p1
%endif
%patch1 -p0
cp %SOURCE50 ./

%build
rm -rf $RPM_BUILD_ROOT

%__mkdir_p %buildroot/%_bindir

%if %bmodulesv
# Step 1: kernel w/ modules
cat %SOURCE1 | \
    sed 's/^CONFIG_LOCALVERSION=/CONFIG_LOCALVERSION="%{kernelversionappend}"/' \
    > .config

yes '' | %make oldconfig ARCH=um
%make modules linux ARCH=um

%make ARCH=um modules_install INSTALL_MOD_PATH=%buildroot
%__cp linux %buildroot/%_bindir/%name-mod-%{_target_cpu}-%mdvkversion
(
cd %buildroot/%_bindir
%__ln_s %name-mod-%{_target_cpu}-%mdvkversion linux-mod-%{_target_cpu}-%mdvkversion

%__ln_s %name-mod-%{_target_cpu}-%mdvkversion %name-mod-%{_target_cpu}
%__ln_s %name-mod-%{_target_cpu} linux-mod-%{_target_cpu}

%__ln_s %name-mod-%{_target_cpu} %name-mod
%__ln_s %name-mod linux-mod
)

cp .config config-mod-%{_target_cpu}-%mdvkversion

%make clean ARCH=um
rm -f .version
%endif

# Step 2: kernel w/o modules

cat %SOURCE1 | \
    sed 's/^CONFIG_LOCALVERSION=/CONFIG_LOCALVERSION="%{kernelversionappend}"/' | \
    sed 's/^CONFIG_MODULES.*/# CONFIG_MODULES is not set/' \
    > .config

yes '' | %make oldconfig ARCH=um
%make linux ARCH=um

%__cp linux %buildroot/%_bindir/%name-%{_target_cpu}-%mdvkversion
(
cd %buildroot/%_bindir
%__ln_s %name-%{_target_cpu}-%mdvkversion linux-%{_target_cpu}-%mdvkversion

%__ln_s %name-%{_target_cpu}-%mdvkversion %name-%{_target_cpu}
%__ln_s %name-%{_target_cpu} linux-%{_target_cpu}

%__ln_s %name-%{_target_cpu} %name
%__ln_s %name linux
)

cp .config config-%{_target_cpu}-%mdvkversion

%make clean ARCH=um
rm -f .version

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README.mdv
%_bindir/%name
%_bindir/linux
%if %bmodulesv
%_bindir/%name-mod
%_bindir/linux-mod
%endif

%files %{_target_cpu}
%defattr(-,root,root)
%doc README.mdv
%_bindir/%name-%{_target_cpu}
%_bindir/linux-%{_target_cpu}
%if %bmodulesv
%_bindir/%name-mod-%{_target_cpu}
%_bindir/linux-mod-%{_target_cpu}
%endif

%files %{_target_cpu}-%{mdvkversion}
%defattr(-,root,root)
%doc Documentation/uml
%doc README.mdv
%_bindir/%name-%{_target_cpu}-%mdvkversion
%_bindir/linux-%{_target_cpu}-%mdvkversion
%doc config-%{_target_cpu}-%mdvkversion
%if %bmodulesv
%_bindir/%name-mod-%{_target_cpu}-%mdvkversion
%_bindir/linux-mod-%{_target_cpu}-%mdvkversion
%doc config-mod-%{_target_cpu}-%mdvkversion
%endif

%if %bmodulesv
%files modules-%{mdvkversion}
%defattr(-,root,root)
%doc README.mdv
%doc config-mod-%{_target_cpu}-%mdvkversion
/lib/modules/*
%endif


%changelog
* Sat Mar 21 2009 Olivier Thauvin <nanardon@mandriva.org> 2.6.28.8-1mdv2009.1
+ Revision: 359868
- 2.6.28.8

* Sat Feb 21 2009 Olivier Thauvin <nanardon@mandriva.org> 2.6.28.7-1mdv2009.1
+ Revision: 343624
- 2.6.28.7

* Wed Feb 18 2009 Olivier Thauvin <nanardon@mandriva.org> 2.6.28.6-1mdv2009.1
+ Revision: 342456
- 2.6.28.6

* Thu Feb 12 2009 Olivier Thauvin <nanardon@mandriva.org> 2.6.28.5-1mdv2009.1
+ Revision: 339930
- 2.6.28.5

* Mon Feb 09 2009 Olivier Thauvin <nanardon@mandriva.org> 2.6.28.4-1mdv2009.1
+ Revision: 338663
- 2.6.28.4

* Sun Feb 01 2009 Olivier Thauvin <nanardon@mandriva.org> 2.6.28.2-1mdv2009.1
+ Revision: 335910
- 2.6.28.2

* Wed Jan 21 2009 Olivier Thauvin <nanardon@mandriva.org> 2.6.28.1-1mdv2009.1
+ Revision: 332355
- 2.6.28.1

* Thu Dec 25 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.28-1mdv2009.1
+ Revision: 318817
- 2.6.28

* Wed Nov 19 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.27.6-1mdv2009.1
+ Revision: 304465
- 2.6.27.6
- 2.6.27.4
- 2.6.27

* Tue Sep 09 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.26.5-1mdv2009.0
+ Revision: 283286
- 2.6.26.5

* Thu Aug 21 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.26.3-1mdv2009.0
+ Revision: 274455
- 2.6.26.3

* Thu Aug 07 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.26.2-1mdv2009.0
+ Revision: 265528
- 2.6.26.2

* Sat Aug 02 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.26.1-1mdv2009.0
+ Revision: 260854
- 2.6.26.1
- modules are not compatibles with same kernel build on another distro, then enforcing kernel extra version with mkrel
- add a provide kernel-uml-modules

* Thu Jul 17 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.26-4mdv2009.0
+ Revision: 236654
- fix deps
- provides config used as doc

* Thu Jul 17 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.26-3mdv2009.0
+ Revision: 236647
- disable MMAPER, make it segfaulting
- use just on default config

* Wed Jul 16 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.26-2mdv2009.0
+ Revision: 236463
- disable hppfs as it doesn't build on i586 (gcc issue)
- enable more support in kernel
- provide both kernel w/ and w/o module support, and a package with modules
- add a README.mdv (woot)
- add release number in kernel/package name
- set LOCALVERSION in kernel, as now we have to make difference in modules tree

* Mon Jul 14 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.26-1mdv2009.0
+ Revision: 234419
- fix arch in name
- 2.6.26

* Sun Jul 13 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.25.10-5mdv2009.0
+ Revision: 234203
- make package name coherent, fix deps

* Sat Jul 12 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.25.10-4mdv2009.0
+ Revision: 234085
- uml kernel is not biarch (64bits kernel cannot run 32bits apps), so handle biarch installation to being able to install both 32 and 64bits kernel on 64bits computer

* Sat Jul 12 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.25.10-3mdv2009.0
+ Revision: 234023
- really fix kernel file name
  > - requires uml-utilities (which are rarelly not used)

* Tue Jul 08 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.25.10-2mdv2009.0
+ Revision: 232668
- fix kernel filename

* Mon Jul 07 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.25.10-1mdv2009.0
+ Revision: 232576
- 2.6.25.10
- package is now versionned

* Thu Apr 24 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.25-1mdv2009.0
+ Revision: 197084
- 2.6.25

* Fri Mar 14 2008 Olivier Thauvin <nanardon@mandriva.org> 2.6.24.3-1mdv2008.1
+ Revision: 187957
- 2.6.24.3

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request
    - import kernel-uml


* Mon Mar 20 2006 Tibor Pittich <Tibor.Pittich@mandriva.org> 2.6.16-1mdk
- 2.6.16
- improve uml options
  - enable pcap transport
- improve kernel options
  - enable ocfs2
  - enable xfrm network sercurity hooks
  - enable md raid5

* Wed Feb 8 2006 Tibor Pittich <Tibor.Pittich@mandriva.org> 2.6.15.6-1mdk
- 2.6.15.6
- regenerated .config

* Fri Dec 16 2005 Tibor Pittich <Tibor.Pittich@mandriva.org> 2.6.14.4-1mdk
- 2.6.14.4
- regenerated .config
  - add fuse support

* Fri Sep 30 2005 Tibor Pittich <Tibor.Pittich@mandriva.org> 2.6.13.2-1mdk
- 2.6.13.2

* Fri Sep 2 2005 Tibor Pittich <Tibor.Pittich@mandriva.org> 2.6.13-1mdk
- 2.6.13

* Sat Jul 9 2005  Tibor Pittich <Tibor.Pittich@mandriva.org> 2.6.12.2-1mdk
- 2.6.12.2
- apply revert-fork-instead-of-clone.patch
- enable software and uml watchdogs

* Thu Jun 23 2005 Tibor Pittich <Tibor.Pittich@mandriva.org> 2.6.12.1-1mdk
- 2.6.12.1

* Tue Jun 21 2005 Tibor Pittich <Tibor.Pittich@mandriva.org> 2.6.12-1mdk
- 2.6.12
- this release can be compiled with gcc4
- regenerated .config
- improve uml options
  - enable hostfs
  - enable network block device
- improve kernel options
  - enable nfs v3,v4 client and server support
  - enable smbfs support and cifs support
  - enable socket and networking security hooks
  - enable nsa boot parameter
  - enable aes cipher
- changes from previous package which has not been released
  - 2.6.11.8
  - total rewrite of spec file
  - change Group
  - improve uml options
    - enable magic sysrq
    - enable synchronous disk IO for UBD
  - improve kernel options
    - add -uml as local version
    - enable PF_KEY, AH and ESP transformation (aka enable ipsec)
    - disable packet generator
    - enable ipv6
    - enable tun/tap support
    - enable security labels on filesystems
    - enable quota format v2
    - disable ntfs write support
    - enable default linux capabilities
    - enable nsa linux
    - disable md_raid 10,5,6, md_multipath
    - enable cryto target for device mapper
    - disable udf due to compilation error
  - %%mkrel
  - rename kernel binary and related symlink due to coherency with package name
  - this package has not been released

* Sun Feb 27 2005 Tibor Pittich <Tibor.Pittich@mandrake.org> 2.6.10-2mdk
- enabled unix sockets (Jean-Christophe Heger)

* Tue Feb 15 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.6.10-1mdk
- new release
- patch 1: fix build
- source 1:
  o update
  o do not automatically mount devfs
- add doc

* Tue Sep 7 2004 Tibor Pittich <Tibor.Pittich@mandrake.org> 2.6.8.1-1mdk
- 2.6.8.1

* Wed Aug 11 2004 Tibor Pittich <Tibor.Pittich@mandrake.org> 2.6.7-1mdk
- 2.6.7

* Mon Jul 19 2004 Tibor Pittich <Tibor.Pittich@mandrake.org> 2.6.6-1mdk
- updated to 2.6.6
- regenerated .config
- some macroszification
- redesigned symlink creation, removed from post

* Thu Oct 09 2003 Olivier Thauvin <thauvin@aerov.jussieu.fr> 2.6.0-0.test5.3mdk
- reupload

* Wed Oct 08 2003 Olivier Thauvin <thauvin@aerov.jussieu.fr> 2.6.0-0.test5.2mdk
- cleanup

* Tue Oct 07 2003 Olivier Thauvin <thauvin@aerov.jussieu.fr> 2.6.0-0.test5.1mdk
- First mdk spec 

